<CsoundSynthesizer>
<CsOptions>
</CsOptions>
<CsInstruments>

sr = 44100
ksmps = 64
0dbfs = 1
nchnls = 2


seed 0
gkflag init 0

opcode AllPass, a, a
	ain xin
	; Generate stable poles
	irad exprand 0.1
	irad = 0.99 - irad
	irad limit irad, 0, 0.99
	;iang random -$M_PI, $M_PI
	iang random -$M_PI, $M_PI
	ireal = irad * cos(iang)
	iimag = irad * sin(iang)
	print irad, iang, ireal, iimag
	
	; Generate coefficients from poles
	ia2 = (ireal * ireal) + (iimag * iimag)
	ia1 = -2*ireal
	ia0 = 1

	ib0 = ia2
	ib1 = ia1
	ib2 = ia0

	printf_i "ia0 = %.8f ia1 = %.8f ia2= %.8f\n", 1, ia0, ia1, ia2
	aout biquad ain, ib0, ib1, ib2, ia0, ia1, ia2
	
	xout aout
endop

opcode Gerzon, aa, akk
	ain, kwidth,kmode xin
	a1 AllPass ain
	a2 AllPass a1
	
	if kmode > 0 then
		a1 AllPass a1
		a2 AllPass a1
	endif	
	if kmode > 1 then
		a1 AllPass a1
		a2 AllPass a1
	endif
	if kmode > 2 then
		a1 AllPass a1
		a2 AllPass a1
	endif
	if kmode > 3 then
		a1 AllPass a1
		a2 AllPass a1
	endif
	if kmode > 4 then
		a1 AllPass a1
		a2 AllPass a1
	endif
	if kmode > 5 then
		a1 AllPass a1
		a2 AllPass a1
	endif
	if kmode > 6 then
		a1 AllPass a1
		a2 AllPass a1
	endif

	aout1 = ain*kwidth + a1
	aout2 = -a2*kwidth + a1
	
	xout aout1, aout2
endop

instr 1  ; Inputs and control
	gainput inch 1
	gkon_gerzon invalue "on_gerzon"
	gkwidth_gerzon invalue "width_gerzon"
	gklevel_gerzon invalue "level_gerzon"
	gkmode_gerzon invalue "mode_gerzon"
endin

instr 2 ; flag filter coefficients reinit
	gkflag = 1
	turnoff
endin

instr 14 ; Gerzon method
start:
if gkon_gerzon == 1 then
	aout1, aout2 Gerzon gainput*gklevel_gerzon, gkwidth_gerzon, gkmode_gerzon
else
	aout1 = gainput*gklevel_gerzon
	aout2 = gainput*gklevel_gerzon
endif

rireturn
if gkflag == 1 then
	gkflag = 0	
	reinit start
endif

outch 1, aout1, 2, aout2
endin

</CsInstruments>
<CsScore>
i 1 0 3600
i 14 0 3600
</CsScore>
</CsoundSynthesizer>
<bsbPanel>
 <label>Widgets</label>
 <objectName/>
 <x>777</x>
 <y>384</y>
 <width>408</width>
 <height>350</height>
 <visible>true</visible>
 <uuid/>
 <bgcolor mode="background">
  <r>170</r>
  <g>170</g>
  <b>127</b>
 </bgcolor>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>7</x>
  <y>6</y>
  <width>382</width>
  <height>324</height>
  <uuid>{4c919985-3409-41f4-8fbb-43e8dfb20801}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Gerzon method</label>
  <alignment>center</alignment>
  <font>DejaVu Sans</font>
  <fontsize>18</fontsize>
  <precision>3</precision>
  <color>
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </color>
  <bgcolor mode="background">
   <r>129</r>
   <g>149</g>
   <b>91</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>5</borderradius>
  <borderwidth>3</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>36</x>
  <y>86</y>
  <width>80</width>
  <height>25</height>
  <uuid>{d4fdb81c-b8c8-4f79-bb49-d0cec19e5607}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Enable</label>
  <alignment>left</alignment>
  <font>Lucida Grande</font>
  <fontsize>12</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBCheckBox">
  <objectName>on_gerzon</objectName>
  <x>18</x>
  <y>88</y>
  <width>20</width>
  <height>20</height>
  <uuid>{66b6c878-2a39-499a-b162-8761109dfc60}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <selected>true</selected>
  <label/>
  <pressedValue>1</pressedValue>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>114</x>
  <y>45</y>
  <width>80</width>
  <height>25</height>
  <uuid>{248a562b-78f5-4645-ba0b-17cbbd43c077}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Width</label>
  <alignment>left</alignment>
  <font>DejaVu Sans</font>
  <fontsize>12</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBHSlider">
  <objectName>width_gerzon</objectName>
  <x>19</x>
  <y>64</y>
  <width>278</width>
  <height>23</height>
  <uuid>{14814ddc-76ed-4069-a177-c2c1ee4a0e12}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <minimum>0.00000000</minimum>
  <maximum>1.00000000</maximum>
  <value>0.38489209</value>
  <mode>lin</mode>
  <mouseControl act="jump">continuous</mouseControl>
  <resolution>-1.00000000</resolution>
  <randomizable group="0">true</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBKnob">
  <objectName>level_gerzon</objectName>
  <x>301</x>
  <y>23</y>
  <width>74</width>
  <height>72</height>
  <uuid>{9a962245-1ac4-41bc-ac0e-2b08a18b5224}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <minimum>0.00000000</minimum>
  <maximum>1.00000000</maximum>
  <value>0.53000000</value>
  <mode>lin</mode>
  <mouseControl act="jump">continuous</mouseControl>
  <resolution>0.01000000</resolution>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>298</x>
  <y>93</y>
  <width>80</width>
  <height>25</height>
  <uuid>{c207900d-6fa8-426d-bd4f-1217f25145e4}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Level</label>
  <alignment>center</alignment>
  <font>DejaVu Sans</font>
  <fontsize>12</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBButton">
  <objectName>button1</objectName>
  <x>213</x>
  <y>155</y>
  <width>166</width>
  <height>29</height>
  <uuid>{0be35d2e-6bbd-4c48-b99e-5c61520dfe62}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <type>event</type>
  <pressedValue>1.00000000</pressedValue>
  <stringvalue/>
  <text>New Filter coefficients</text>
  <image>/</image>
  <eventLine>i 2 0 1</eventLine>
  <latch>false</latch>
  <latched>false</latched>
 </bsbObject>
 <bsbObject version="2" type="BSBScope">
  <objectName/>
  <x>16</x>
  <y>135</y>
  <width>192</width>
  <height>181</height>
  <uuid>{797f859d-d72b-4dbd-9608-86005905acf4}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <value>-255.00000000</value>
  <type>lissajou</type>
  <zoomx>2.00000000</zoomx>
  <zoomy>2.00000000</zoomy>
  <dispx>1.00000000</dispx>
  <dispy>1.00000000</dispy>
  <mode>0.00000000</mode>
 </bsbObject>
 <bsbObject version="2" type="BSBDropdown">
  <objectName>mode_gerzon</objectName>
  <x>265</x>
  <y>232</y>
  <width>80</width>
  <height>30</height>
  <uuid>{8b26c526-b7fa-4e97-9787-4ad034be25c4}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <bsbDropdownItemList>
   <bsbDropdownItem>
    <name>2-pole</name>
    <value>0</value>
    <stringvalue/>
   </bsbDropdownItem>
   <bsbDropdownItem>
    <name>4-pole</name>
    <value>1</value>
    <stringvalue/>
   </bsbDropdownItem>
   <bsbDropdownItem>
    <name>6-pole</name>
    <value>2</value>
    <stringvalue/>
   </bsbDropdownItem>
   <bsbDropdownItem>
    <name>8-pole</name>
    <value>3</value>
    <stringvalue/>
   </bsbDropdownItem>
   <bsbDropdownItem>
    <name>10-pole</name>
    <value>4</value>
    <stringvalue/>
   </bsbDropdownItem>
   <bsbDropdownItem>
    <name>12-pole</name>
    <value>5</value>
    <stringvalue/>
   </bsbDropdownItem>
   <bsbDropdownItem>
    <name>14-pole</name>
    <value>6</value>
    <stringvalue/>
   </bsbDropdownItem>
  </bsbDropdownItemList>
  <selectedIndex>6</selectedIndex>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>233</x>
  <y>208</y>
  <width>140</width>
  <height>24</height>
  <uuid>{414e0875-d51e-4164-8d4e-8142c2cd09d4}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Second filter mode</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>12</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
</bsbPanel>
<bsbPresets>
</bsbPresets>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: Window
WindowBounds: 72 179 400 200
CurrentView: io
IOViewEdit: On
Options:
</MacOptions>

<MacGUI>
ioView background {43690, 43690, 32639}
ioText {7, 6} {381, 124} label 0.000000 0.00100 "" center "DejaVu Sans" 18 {65280, 65280, 65280} {33024, 38144, 23296} nobackground noborder Gerzon method
ioText {36, 86} {80, 25} label 0.000000 0.00100 "" left "Lucida Grande" 12 {0, 0, 0} {63232, 62720, 61952} nobackground noborder Enable
ioCheckbox {18, 88} {20, 20} on on_gerzon
ioText {114, 45} {80, 25} label 0.000000 0.00100 "" left "DejaVu Sans" 12 {0, 0, 0} {63232, 62720, 61952} nobackground noborder Width
ioSlider {19, 64} {278, 23} 0.000000 1.000000 0.384892 width_gerzon
ioKnob {301, 23} {74, 72} 1.000000 0.000000 0.010000 0.530000 level_gerzon
ioText {298, 93} {80, 25} label 0.000000 0.00100 "" center "DejaVu Sans" 12 {0, 0, 0} {63232, 62720, 61952} nobackground noborder Level
ioButton {213, 155} {166, 29} event 1.000000 "button1" "New Filter coefficients" "/" i 2 0 1
ioGraph {16, 135} {192, 181} lissajou 2.000000 -255 
ioMenu {265, 232} {80, 30} 6 303 "2-pole,4-pole,6-pole,8-pole,10-pole,12-pole,14-pole" mode_gerzon
ioText {237, 208} {140, 24} label 0.000000 0.00100 "" center "Arial" 12 {0, 0, 0} {63232, 62720, 61952} nobackground noborder Second filter mode
</MacGUI>
<EventPanel name="" tempo="60.00000000" loop="8.00000000" x="436" y="425" width="655" height="346" visible="true" loopStart="0" loopEnd="0">s as d  </EventPanel>
